package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.DataEntity;

/**
 * 实体[MsgTemplate] 数据对象
 */
@TableName(value = "T_SRFMSGTEMPLATE",resultMap = "MsgTemplateResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class MsgTemplate extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private DataEntity de;
    private String content;
    @Dict(dictName = "ionicdemo_MsgContentTypeCodeList")
    private String contenttype;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String deid;
    @TableField(exist = false)//逻辑属性
    private String dename;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    @TableLogic(value= "1",delval="0")//设定逻辑有效属性
    @TableField(fill = FieldFill.INSERT)
    private Integer enable;
    private String imcontent;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer mailgroupsend;
    @TableId(value= "msgtemplateid",type=IdType.UUID)//指定主键生成策略
    private String msgtemplateid;
    private String msgtemplatename;
    private String reserver;
    private String reserver2;
    private String reserver3;
    private String reserver4;
    private String smscontent;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer srfsyspub;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer srfuserpub;
    private String subject;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    private String wccontent;
    /**
     *  设置属性值[内容]
     *  @param content
     */
    public void setContent(String content){
        if(StringUtils.isEmpty(content))
            content=null;
        this.content = content;
        this.set("contentdirtyflag",true);
    }
    /**
     *  获取属性值[内容]
     */
    public String getContent(){
        return this.content;
    }
    /**
     *  重置属性值[内容]
     */
    public void resetContent(){
        this.set("contentdirtyflag",false);
        this.content = null;
    }
    /**
     *  设置属性值[内容类型]
     *  @param contenttype
     */
    public void setContenttype(String contenttype){
        if(StringUtils.isEmpty(contenttype))
            contenttype=null;
        this.contenttype = contenttype;
        this.set("contenttypedirtyflag",true);
    }
    /**
     *  获取属性值[内容类型]
     */
    public String getContenttype(){
        return this.contenttype;
    }
    /**
     *  重置属性值[内容类型]
     */
    public void resetContenttype(){
        this.set("contenttypedirtyflag",false);
        this.contenttype = null;
    }
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[数据实体]
     *  @param deid
     */
    public void setDeid(String deid){
        if(StringUtils.isEmpty(deid))
            deid=null;
        this.deid = deid;
        this.set("deiddirtyflag",true);
    }
    /**
     *  获取属性值[数据实体]
     */
    public String getDeid(){
        return this.deid;
    }
    /**
     *  重置属性值[数据实体]
     */
    public void resetDeid(){
        this.set("deiddirtyflag",false);
        this.deid = null;
    }
    /**
     *  设置属性值[数据实体]
     *  @param dename
     */
    public void setDename(String dename){
        if(StringUtils.isEmpty(dename))
            dename=null;
        this.dename = dename;
        this.set("denamedirtyflag",true);
    }
    /**
     *  获取属性值[数据实体]
     */
    public String getDename(){
        return this.dename;
    }
    /**
     *  重置属性值[数据实体]
     */
    public void resetDename(){
        this.set("denamedirtyflag",false);
        this.dename = null;
    }
    /**
     *  设置属性值[逻辑有效标志]
     *  @param enable
     */
    public void setEnable(Integer enable){
        this.enable = enable;
        this.set("enabledirtyflag",true);
    }
    /**
     *  获取属性值[逻辑有效标志]
     */
    public Integer getEnable(){
        if(StringUtils.isEmpty(enable))
        {
            this.enable = 1;//设置逻辑有效值
            this.set("enabledirtyflag",true);
        }
        return this.enable;
    }
    /**
     *  重置属性值[逻辑有效标志]
     */
    public void resetEnable(){
        this.set("enabledirtyflag",false);
        this.enable = null;
    }
    /**
     *  设置属性值[IM消息内容]
     *  @param imcontent
     */
    public void setImcontent(String imcontent){
        if(StringUtils.isEmpty(imcontent))
            imcontent=null;
        this.imcontent = imcontent;
        this.set("imcontentdirtyflag",true);
    }
    /**
     *  获取属性值[IM消息内容]
     */
    public String getImcontent(){
        return this.imcontent;
    }
    /**
     *  重置属性值[IM消息内容]
     */
    public void resetImcontent(){
        this.set("imcontentdirtyflag",false);
        this.imcontent = null;
    }
    /**
     *  设置属性值[邮件群组发送]
     *  @param mailgroupsend
     */
    public void setMailgroupsend(Integer mailgroupsend){
        this.mailgroupsend = mailgroupsend;
        this.set("mailgroupsenddirtyflag",true);
    }
    /**
     *  获取属性值[邮件群组发送]
     */
    public Integer getMailgroupsend(){
        return this.mailgroupsend;
    }
    /**
     *  重置属性值[邮件群组发送]
     */
    public void resetMailgroupsend(){
        this.set("mailgroupsenddirtyflag",false);
        this.mailgroupsend = null;
    }
    /**
     *  设置属性值[消息模板标识]
     *  @param msgtemplateid
     */
    public void setMsgtemplateid(String msgtemplateid){
        if(StringUtils.isEmpty(msgtemplateid))
            msgtemplateid=null;
        this.msgtemplateid = msgtemplateid;
        this.set("msgtemplateiddirtyflag",true);
    }
    /**
     *  获取属性值[消息模板标识]
     */
    public String getMsgtemplateid(){
        return this.msgtemplateid;
    }
    /**
     *  重置属性值[消息模板标识]
     */
    public void resetMsgtemplateid(){
        this.set("msgtemplateiddirtyflag",false);
        this.msgtemplateid = null;
    }
    /**
     *  设置属性值[消息模板名称]
     *  @param msgtemplatename
     */
    public void setMsgtemplatename(String msgtemplatename){
        if(StringUtils.isEmpty(msgtemplatename))
            msgtemplatename=null;
        this.msgtemplatename = msgtemplatename;
        this.set("msgtemplatenamedirtyflag",true);
    }
    /**
     *  获取属性值[消息模板名称]
     */
    public String getMsgtemplatename(){
        return this.msgtemplatename;
    }
    /**
     *  重置属性值[消息模板名称]
     */
    public void resetMsgtemplatename(){
        this.set("msgtemplatenamedirtyflag",false);
        this.msgtemplatename = null;
    }
    /**
     *  设置属性值[保留字段]
     *  @param reserver
     */
    public void setReserver(String reserver){
        if(StringUtils.isEmpty(reserver))
            reserver=null;
        this.reserver = reserver;
        this.set("reserverdirtyflag",true);
    }
    /**
     *  获取属性值[保留字段]
     */
    public String getReserver(){
        return this.reserver;
    }
    /**
     *  重置属性值[保留字段]
     */
    public void resetReserver(){
        this.set("reserverdirtyflag",false);
        this.reserver = null;
    }
    /**
     *  设置属性值[保留字段2]
     *  @param reserver2
     */
    public void setReserver2(String reserver2){
        if(StringUtils.isEmpty(reserver2))
            reserver2=null;
        this.reserver2 = reserver2;
        this.set("reserver2dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段2]
     */
    public String getReserver2(){
        return this.reserver2;
    }
    /**
     *  重置属性值[保留字段2]
     */
    public void resetReserver2(){
        this.set("reserver2dirtyflag",false);
        this.reserver2 = null;
    }
    /**
     *  设置属性值[保留字段3]
     *  @param reserver3
     */
    public void setReserver3(String reserver3){
        if(StringUtils.isEmpty(reserver3))
            reserver3=null;
        this.reserver3 = reserver3;
        this.set("reserver3dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段3]
     */
    public String getReserver3(){
        return this.reserver3;
    }
    /**
     *  重置属性值[保留字段3]
     */
    public void resetReserver3(){
        this.set("reserver3dirtyflag",false);
        this.reserver3 = null;
    }
    /**
     *  设置属性值[保留字段4]
     *  @param reserver4
     */
    public void setReserver4(String reserver4){
        if(StringUtils.isEmpty(reserver4))
            reserver4=null;
        this.reserver4 = reserver4;
        this.set("reserver4dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段4]
     */
    public String getReserver4(){
        return this.reserver4;
    }
    /**
     *  重置属性值[保留字段4]
     */
    public void resetReserver4(){
        this.set("reserver4dirtyflag",false);
        this.reserver4 = null;
    }
    /**
     *  设置属性值[手机消息内容]
     *  @param smscontent
     */
    public void setSmscontent(String smscontent){
        if(StringUtils.isEmpty(smscontent))
            smscontent=null;
        this.smscontent = smscontent;
        this.set("smscontentdirtyflag",true);
    }
    /**
     *  获取属性值[手机消息内容]
     */
    public String getSmscontent(){
        return this.smscontent;
    }
    /**
     *  重置属性值[手机消息内容]
     */
    public void resetSmscontent(){
        this.set("smscontentdirtyflag",false);
        this.smscontent = null;
    }
    /**
     *  设置属性值[框架发布]
     *  @param srfsyspub
     */
    public void setSrfsyspub(Integer srfsyspub){
        this.srfsyspub = srfsyspub;
        this.set("srfsyspubdirtyflag",true);
    }
    /**
     *  获取属性值[框架发布]
     */
    public Integer getSrfsyspub(){
        return this.srfsyspub;
    }
    /**
     *  重置属性值[框架发布]
     */
    public void resetSrfsyspub(){
        this.set("srfsyspubdirtyflag",false);
        this.srfsyspub = null;
    }
    /**
     *  设置属性值[应用发布]
     *  @param srfuserpub
     */
    public void setSrfuserpub(Integer srfuserpub){
        this.srfuserpub = srfuserpub;
        this.set("srfuserpubdirtyflag",true);
    }
    /**
     *  获取属性值[应用发布]
     */
    public Integer getSrfuserpub(){
        return this.srfuserpub;
    }
    /**
     *  重置属性值[应用发布]
     */
    public void resetSrfuserpub(){
        this.set("srfuserpubdirtyflag",false);
        this.srfuserpub = null;
    }
    /**
     *  设置属性值[标题]
     *  @param subject
     */
    public void setSubject(String subject){
        if(StringUtils.isEmpty(subject))
            subject=null;
        this.subject = subject;
        this.set("subjectdirtyflag",true);
    }
    /**
     *  获取属性值[标题]
     */
    public String getSubject(){
        return this.subject;
    }
    /**
     *  重置属性值[标题]
     */
    public void resetSubject(){
        this.set("subjectdirtyflag",false);
        this.subject = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[微信内容]
     *  @param wccontent
     */
    public void setWccontent(String wccontent){
        if(StringUtils.isEmpty(wccontent))
            wccontent=null;
        this.wccontent = wccontent;
        this.set("wccontentdirtyflag",true);
    }
    /**
     *  获取属性值[微信内容]
     */
    public String getWccontent(){
        return this.wccontent;
    }
    /**
     *  重置属性值[微信内容]
     */
    public void resetWccontent(){
        this.set("wccontentdirtyflag",false);
        this.wccontent = null;
    }
     /**
     *  获取主实体关联数据[DataEntity]
     */
    public DataEntity getDe() {
        return de;
    }
    /**
     *  设置主实体关联数据[DataEntity]
     */
    public void setDe(DataEntity de) {
        this.de = de;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetContent();
        resetContenttype();
        resetCreatedate();
        resetCreateman();
        resetDeid();
        resetDename();
        resetEnable();
        resetImcontent();
        resetMailgroupsend();
        resetMsgtemplateid();
        resetMsgtemplatename();
        resetReserver();
        resetReserver2();
        resetReserver3();
        resetReserver4();
        resetSmscontent();
        resetSrfsyspub();
        resetSrfuserpub();
        resetSubject();
        resetUpdatedate();
        resetUpdateman();
        resetWccontent();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public MsgTemplate copyTo(MsgTemplate targetEntity)
	{
		BeanCopier copier=BeanCopier.create(MsgTemplate.class, MsgTemplate.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetMsgtemplateid();
		return targetEntity;
	}
}